//+------------------------------------------------------------------+
//|                                      normalized jurik filter.mq4 |
//|                                                           mladen |
//+------------------------------------------------------------------+
#property copyright "mladen"
#property link      "mladenfx@gmail.com"

#property indicator_separate_window
#property indicator_buffers  5
#property indicator_color1   DeepSkyBlue
#property indicator_color2   PaleVioletRed
#property indicator_color3   PaleVioletRed
#property indicator_width1   2
#property indicator_width2   2
#property indicator_width3   2

//
//
//
//
//

extern double SmoothLength        = 25;
extern double SmoothPhase         =  0;
extern int    Price               = PRICE_CLOSE;
extern int    NormalizeLength     = 30;
extern bool   NormalizeHyperbolic = false;
extern double LevelUp             = 0.8;
extern double LevelDown           = 0.2;
extern bool   MultiColor          = true;

//
//
//
//
//

double no[];
double noDa[];
double noDb[];
double liu[];
double lid[];
double values[];
double slope[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(7);
      SetIndexBuffer(0,no);
      SetIndexBuffer(1,noDa);
      SetIndexBuffer(2,noDb);
      SetIndexBuffer(3,liu); SetIndexStyle(3,DRAW_NONE);
      SetIndexBuffer(4,lid); SetIndexStyle(4,DRAW_NONE);
      SetIndexBuffer(5,values);
      SetIndexBuffer(6,slope);
   
      //
      //
      //
      //
      //
      
         if (NormalizeHyperbolic)
            {
               SetLevelValue(0,2.0*(LevelUp  -0.5));
               SetLevelValue(1,2.0*(LevelDown-0.5));
               SetLevelValue(2,0.0);
            }
         else            
            {
               SetLevelValue(0,LevelUp  );
               SetLevelValue(1,LevelDown);
               SetLevelValue(2,0.5);
            }
            
      //
      //
      //
      //
      //
                  
   string IndicatorAddName  = ""; if (NormalizeHyperbolic) IndicatorAddName = " hyperbolic";
   IndicatorShortName("sigmoidal"+IndicatorAddName+" normalized filter("+DoubleToStr(SmoothLength,2)+")");
   return(0);
}
int deinit() { return(0); }



//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int i,limit,counted_bars=IndicatorCounted();
   

   if(counted_bars < 0) return(-1);
   if(counted_bars > 0) counted_bars--;
           limit = MathMin(Bars-counted_bars,Bars-1);

   //
   //
   //
   //
   //
   
   if (MultiColor && slope[limit]==-1) CleanPoint(limit,noDa,noDb);
   for(i=limit; i>=0; i--)
   {
      values[i] = iSmooth(iMA(NULL,0,1,0,MODE_SMA,Price,i),SmoothLength,SmoothPhase,i);   
      liu[i]    = 1;
      slope[i]  = slope[i+1];
      noDa[i]   = EMPTY_VALUE;
      noDb[i]   = EMPTY_VALUE;
         
      //
      //
      //
      //
      //
               
      double mean      = iSma(NormalizeLength,i);
      double deviation = iDeviation(NormalizeLength,mean,i);
      double zeroMean  = 0;
         if (deviation != 0) zeroMean = (values[i]-mean)/deviation;
         if (NormalizeHyperbolic)
               { lid[i] = -1; no[i] = (1.0-MathExp(-zeroMean))/(1.0+MathExp(-zeroMean)); }
         else  { lid[i] =  0; no[i] = 1.0/(1.0+MathExp(-zeroMean)); }
         if (no[i] > no[i+1]) slope[i] =  1;
         if (no[i] < no[i+1]) slope[i] = -1;
         if (MultiColor && slope[i]==-1) PlotPoint(i,noDa,noDb,no);
   }

   //
   //
   //
   //
   //
      
   return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

double iDeviation(int period, double dMA, int pos)
{
   double dSum = 0;
      for(int i=0; i<period; i++,pos++) dSum += (values[pos]-dMA)*(values[pos]-dMA);
   return(MathSqrt(dSum/period));
}

//
//
//
//
//

double iSma(int period, int pos)
{
   double sum = values[pos];
      for(int i=1; i<period; i++) sum += values[pos+i];
   return(sum/period);
}

//+------------------------------------------------------------------
//|                                                                 
//+------------------------------------------------------------------
//
//
//
//
//

double wrk[][10];
#define bsmax  5
#define bsmin  6
#define volty  7
#define vsum   8
#define avolty 9

//
//
//
//
//

double iSmooth(double price, double length, double phase, int i, int s=0)
{
   if (ArrayRange(wrk,0) != Bars) ArrayResize(wrk,Bars);
   
   int r = Bars-i-1; 
      if (r==0) { for(int k=0; k<7; k++) wrk[0][k+s]=price; for(; k<10; k++) wrk[0][k+s]=0; return(price); }

   //
   //
   //
   //
   //
   
      double len1   = MathMax(MathLog(MathSqrt(0.5*(length-1)))/MathLog(2.0)+2.0,0);
      double pow1   = MathMax(len1-2.0,0.5);
      double del1   = price - wrk[r-1][bsmax+s];
      double del2   = price - wrk[r-1][bsmin+s];
      double div    = 1.0/(10.0+10.0*(MathMin(MathMax(length-10,0),100))/100);
      int    forBar = MathMin(r,10);
	
         wrk[r][volty+s] = 0;
               if(MathAbs(del1) > MathAbs(del2)) wrk[r][volty+s] = MathAbs(del1); 
               if(MathAbs(del1) < MathAbs(del2)) wrk[r][volty+s] = MathAbs(del2); 
         wrk[r][vsum+s] =	wrk[r-1][vsum+s] + (wrk[r][volty+s]-wrk[r-forBar][volty+s])*div;
         
         //
         //
         //
         //
         //
   
         wrk[r][avolty+s] = wrk[r-1][avolty+s]+(2.0/(MathMax(4.0*length,30)+1.0))*(wrk[r][vsum+s]-wrk[r-1][avolty+s]);
            if (wrk[r][avolty+s] > 0)
               double dVolty = wrk[r][volty+s]/wrk[r][avolty+s]; else dVolty = 0;   
	               if (dVolty > MathPow(len1,1.0/pow1)) dVolty = MathPow(len1,1.0/pow1);
                  if (dVolty < 1)                      dVolty = 1.0;

      //
      //
      //
      //
      //
	        
   	double pow2 = MathPow(dVolty, pow1);
      double len2 = MathSqrt(0.5*(length-1))*len1;
      double Kv   = MathPow(len2/(len2+1), MathSqrt(pow2));

         if (del1 > 0) wrk[r][bsmax+s] = price; else wrk[r][bsmax+s] = price - Kv*del1;
         if (del2 < 0) wrk[r][bsmin+s] = price; else wrk[r][bsmin+s] = price - Kv*del2;
	
   //
   //
   //
   //
   //
      
      double R     = MathMax(MathMin(phase,100),-100)/100.0 + 1.5;
      double beta  = 0.45*(length-1)/(0.45*(length-1)+2);
      double alpha = MathPow(beta,pow2);

         wrk[r][0+s] = price + alpha*(wrk[r-1][0+s]-price);
         wrk[r][1+s] = (price - wrk[r][0+s])*(1-beta) + beta*wrk[r-1][1+s];
         wrk[r][2+s] = (wrk[r][0+s] + R*wrk[r][1+s]);
         wrk[r][3+s] = (wrk[r][2+s] - wrk[r-1][4+s])*MathPow((1-alpha),2) + MathPow(alpha,2)*wrk[r-1][3+s];
         wrk[r][4+s] = (wrk[r-1][4+s] + wrk[r][3+s]); 

   //
   //
   //
   //
   //

   return(wrk[r][4+s]);
}

//+-------------------------------------------------------------------
//|                                                                  
//+-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}